# Algorithmes et structures de données 2020-21

Contenu du cours 3 du 30.09.2020

*****

##  Tableaux à deux dimensions

-   Image noir et blanc avec des booléens : initialisation  
```C
      int n = 8, m = 8;
      bool image_nb[n][m];
      for (int i=0;i<n;i++) {
          for (int j=0;j<m;j++) {
              image_nb[i][j] = true;
          }
      }
```
-   Image en niveaux de gris : initialisation  
```C
      int n = 8, m = 8;
      int image_gris[n][m];
      for (int i=0;i<n;i++) {
          for (int j=0;j<m;j++) {
              image_gris[i][j] = rand()%256;
          }
      }
```
>
* Négatif d'une image à 256 niveaux de gris  
    - Appliquer à chaque pixel l'opération `pixel = 255 - pixel`  
```C
                  for (int i=0;i<n;i++) {
                      for (int j=0;j<m;j++) {
                          image_gris[i][j] = 255 - ­image_gris[i][j];
                      }
                  }

```

## Type énuméré

-   On définit un type énuméré `semaine, coin, mois, couleur, direction` en énumérant toutes ses valeurs possibles.   
    Explicitement

```C
        enum semaine {lu,ma,me,je,ve,sa,di};
        enum coin {cinq_cts=5,dix_cts=10,vingt_cts=20,euro=100};
        enum mois {
            jan=1,feb,mar,apr,mai,jun,jul,aug,sep,oct,nov,dec
        };
        enum couleur {RED,GREEN,BLUE};
        enum direction {EST=2,OUEST=3,NORD=0,SUD=1};
```

> Les valeurs d’un type énuméré peuvent être considérées comme des entiers.
Sans précision particulière, le premier élément correspond à 0 et les suivants à 1, 2, etc. 
Sinon on peut explicitement spécifier des valeurs.
Rien n’empêche d'attribuer plusieurs fois le même nombre.

## Opérateur de contrôle `switch`

-   Comparaison entre une valeur et un ensemble de choix pour sélectionner une action à effectuer. Toutes les possibilités doivent être prises en compte.

```C
      void main() {
          type data = id1;
          int val;
          switch(data) {
              case ID1: val = data+1; break;
              case ID2: val = data*2; break;
              case ID3: val = data/3.0; break;
          };
          println!(\"val =%d\\n\",val);
      }
```

## Exemple de la « couverture de la reine »

```C
    enum piece {SAFE,VULN,QUEEN};
    int size = 8;
    piece board[size][size];
    // initialisation de l'échiquier
    for (int i=0;i<size;i++) {
        for (int j=0;j<size;j++) {
            board[i][j] = SAFE;
        }
    }
    int pos_reine[] = {3,4};
    // couverture sans les diagonales !!!
    for (int k=0;k<size;k++) {
        board[k][pos_reine[1]] = VULN;
        board[pos_reine[0]][k] = VULN;
    }
    board[pos_reine[0]][pos_reine[1]] = QUEEN;
```

## Matrices

1. Tableau 2D de nombres

2.  Opérations arithmétiques
    1. Addition : `C = A+B`
    2. Soustraction : `C = A-B`
    3. Multiplication : `C = A*B` (produit lignes/colonnes)
    4. Puissance entière : `C = A`<sup>n</sup>

